---
title: Broadcast Channel API
slug: Web/API/Broadcast_Channel_API
tags:
  - API
  - Broadcast Channel API
  - HTML API
  - Overview
  - Reference
---
<p>{{DefaultAPISidebar("Broadcast Channel API")}}</p>

<p><span class="seoSummary">The <strong>Broadcast Channel API</strong> allows basic communication between {{glossary("browsing context", "browsing contexts")}} (that is, <em>windows</em>, <em>tabs</em>, <em>frames</em>, or <em>iframes</em>) and workers on the same {{glossary("origin")}}.</span></p>

<p>{{AvailableInWorkers}}</p>

<p>By creating a {{domxref("BroadcastChannel")}} object, you can receive any messages that are posted to it. You don't have to maintain a reference to the frames or workers you wish to communicate with: they can “subscribe” to a particular channel by constructing their own {{domxref("BroadcastChannel")}} with the same name, and have bi-directional communication between all of them.</p>

<p><img alt="The principle of the Broadcast Channel API" src="https://mdn.mozillademos.org/files/9945/BroadcastChannel.png" style="height: 448px; width: 784px;"></p>

<h2 id="Broadcast_Channel_interface">Broadcast Channel interface</h2>

<h3 id="Creating_or_joining_a_channel">Creating or joining a channel</h3>

<p>A client joins a broadcast channel by creating a {{domxref("BroadcastChannel")}} object. Its <a href="/en-US/docs/Web/API/BroadcastChannel.BroadcastChannel">constructor</a> takes one single parameter: the <em>name</em> of the channel. If it is the first to connect to that broadcast channel name, the underlying channel is created.</p>

<pre class="brush: js">// Connection to a broadcast channel
const bc = new BroadcastChannel('test_channel');
</pre>

<h3 id="Sending_a_message">Sending a message</h3>

<p>It is enough to call the {{domxref("BroadcastChannel.postMessage", "postMessage()")}} method on the created <code>BroadcastChannel</code> object, which takes any object as an argument. An example string message:</p>

<pre class="brush: js">// Example of sending of a very simple message
bc.postMessage('This is a test message.');
</pre>

<p>Any kind of object can be sent, not just a {{domxref("DOMString")}}.</p>

<p>The API doesn't associate any semantics to messages, so it is up to the code to know what kind of messages to expect and what to do with them.</p>

<h3 id="Receiving_a_message">Receiving a message</h3>

<p>When a message is posted, a {{event("message")}} event is dispatched to each {{domxref("BroadcastChannel")}} object connected to this channel. A function can be run for this event with the {{domxref("BroadcastChannel.onmessage", "onmessage")}} event handler:</p>

<pre class="brush: js">// A handler that only logs the event to the console:
bc.onmessage = function (ev) { console.log(ev); }
</pre>

<h3 id="Disconnecting_a_channel">Disconnecting a channel</h3>

<p>To leave a channel, call the {{domxref("BroadcastChannel.close", "close()")}} method on the object. This disconnects the object from the underlying channel, allowing garbage collection.</p>

<pre class="brush: js">// Disconnect the channel
bc.close();
</pre>

<h2 id="Conclusion">Conclusion</h2>

<p>The Broadcast Channel API's self-contained interface allows cross-context communication. It can be used to detect user actions in other tabs within a same origin, like when the user logs in or out.</p>

<p>The messaging protocol is not defined and the different browsing contexts need to implement it themselves; there is no negotiation nor requirement from the specification.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('HTML WHATWG', "comms.html#broadcasting-to-other-browsing-contexts", "The Broadcast Channel API")}}</td>
   <td>{{Spec2('HTML WHATWG')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.BroadcastChannel")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("BroadcastChannel")}}, the interface implementing it.</li>
</ul>
